#include <zombie_escape>

new const g_szSndExplosion[] = "exp2_frost.wav"

enum _:Sprites
{
	SPRITE_CYLINDER,
	SPRITE_FROST,
	//SPRITE_FROST2,
	SPRITE_FLAKE,
	SPRITE_BEAM2
}

new g_iSprites[Sprites]

public plugin_precache()
{
	precache_sound(g_szSndExplosion)
	
	g_iSprites[SPRITE_CYLINDER] = precache_model("sprites/white.spr")
	g_iSprites[SPRITE_FROST] = precache_model("sprites/new_effect/frost_explode.spr")
	//g_iSprites[SPRITE_FROST2] = precache_model("sprites/new_frostexp_2.spr")
	g_iSprites[SPRITE_FLAKE] = precache_model("sprites/new_effect/frost_gib.spr")
	g_iSprites[SPRITE_BEAM2] = precache_model("sprites/new_effect/frost_trail.spr")
}

public plugin_init()
{
	register_plugin("[ZE] FrostNade Effects", "1.1", "Raheem")
}

public grenade_throw(id, iEnt, iWeapon)
{
	switch(iWeapon)
	{
		case CSW_FLASHBANG:
		{
			UTIL_BeamFollow(iEnt, g_iSprites[SPRITE_BEAM2], 20, 10, 0, 128, 255, 255)
		}
		case CSW_SMOKEGRENADE:
		{
			UTIL_BeamFollow(iEnt, g_iSprites[SPRITE_BEAM2], 20, 10, 0, 128, 255, 255)
		}
	}
}

public ze_frost_pre(iEnt)
{
	emit_sound(iEnt, CHAN_AUTO, g_szSndExplosion, VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
			
	UTIL_Explosion(iEnt, g_iSprites[SPRITE_FROST], 40, 30, 4)
	//UTIL_Explosion(iEnt, g_iSprites[SPRITE_FROST2], 20, 30, 4)
		
	UTIL_DLight(iEnt, 80, 0, 128, 255, 50, 40)
	UTIL_BeamCylinder(iEnt, g_iSprites[SPRITE_CYLINDER], 0, 5, 10, 255, 0, 128, 255, 255, 0)
	UTIL_SpriteTrail(iEnt, g_iSprites[SPRITE_FLAKE], 30, 3, 2, 30, 0)
	
	return PLUGIN_CONTINUE
}
	
UTIL_BeamCylinder(iEnt, iSprite, iFramerate, iLife, iWidth, iAmplitude, iRed, iGreen, iBlue, iBright, iSpeed)
{
	new Float:vOrigin[3]
	get_entvar(iEnt, var_origin, vOrigin)
	
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(TE_BEAMCYLINDER)
	engfunc(EngFunc_WriteCoord, vOrigin[0])
	engfunc(EngFunc_WriteCoord, vOrigin[1])
	engfunc(EngFunc_WriteCoord, vOrigin[2] + 10)
	engfunc(EngFunc_WriteCoord, vOrigin[0] );
	engfunc(EngFunc_WriteCoord, vOrigin[1] + 400)
	engfunc(EngFunc_WriteCoord, vOrigin[2] + 400)
	write_short(iSprite)
	write_byte(0)
	write_byte(iFramerate)
	write_byte(iLife)
	write_byte(iWidth)
	write_byte(iAmplitude)
	write_byte(iRed)
	write_byte(iGreen)
	write_byte(iBlue)
	write_byte(iBright)
	write_byte(iSpeed)
	message_end()
}
	
UTIL_BeamFollow(iEnt, iSprite, iLife, iWidth, iRed, iGreen, iBlue, iBright)
{
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(TE_BEAMFOLLOW)
	write_short(iEnt)
	write_short(iSprite)
	write_byte(iLife)
	write_byte(iWidth)
	write_byte(iRed)
	write_byte(iGreen)
	write_byte(iBlue)
	write_byte(iBright)
	message_end()
}

UTIL_DLight(iEnt, iRadius, iRed, iGreen, iBlue, iLife, iDecay)
{
	new Float:vOrigin[3]
	get_entvar(iEnt, var_origin, vOrigin)
	
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(TE_DLIGHT)
	engfunc(EngFunc_WriteCoord, vOrigin[0])
	engfunc(EngFunc_WriteCoord, vOrigin[1])
	engfunc(EngFunc_WriteCoord, vOrigin[2])
	write_byte(iRadius)
	write_byte(iRed)
	write_byte(iGreen)
	write_byte(iBlue)
	write_byte(iLife)
	write_byte(iDecay)
	message_end()
}

UTIL_Explosion(iEnt, iSprite, iScale, iFramerate, Flags)
{
	new Float:vOrigin[3]
	get_entvar(iEnt, var_origin, vOrigin)
	
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte( TE_EXPLOSION )
	engfunc(EngFunc_WriteCoord, vOrigin[0])
	engfunc(EngFunc_WriteCoord, vOrigin[1])
	engfunc(EngFunc_WriteCoord, vOrigin[2])
	write_short(iSprite)
	write_byte(iScale)
	write_byte(iFramerate)
	write_byte(Flags)
	message_end()
}

UTIL_SpriteTrail(iEnt, iSprite, iCount, iLife, iScale, iVelocity, iVary)
{
	new Float:vOrigin[3]
	get_entvar(iEnt, var_origin, vOrigin)
	
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(TE_SPRITETRAIL)
	engfunc(EngFunc_WriteCoord, vOrigin[0])
	engfunc(EngFunc_WriteCoord, vOrigin[1])
	engfunc(EngFunc_WriteCoord, vOrigin[2] + 100)
	engfunc(EngFunc_WriteCoord, vOrigin[0] + random_float(-200.0, 200.0))
	engfunc(EngFunc_WriteCoord, vOrigin[1] + random_float(-200.0, 200.0))
	engfunc(EngFunc_WriteCoord, vOrigin[2])
	write_short(iSprite)
	write_byte(iCount)
	write_byte(iLife)
	write_byte(iScale)
	write_byte(iVelocity)
	write_byte(iVary)
	message_end()
}